package goodies {

	import flash.desktop.Clipboard;
	import flash.desktop.ClipboardFormats;
	import flash.desktop.NativeDragManager;
	import flash.desktop.NativeDragOptions;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.InteractiveObject;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import mx.formatters.DateFormatter;
	import mx.graphics.codec.PNGEncoder;

	public class DragBitmap {

		private var _displayObject:InteractiveObject;
		private var dateFormatter:DateFormatter;

		public var dragIcon:BitmapData;

		public function DragBitmap() {
			var loader:Loader = new Loader();
            loader.contentLoaderInfo.addEventListener(Event.COMPLETE,
				function ():void
				{
					dragIcon = Bitmap(loader.content).bitmapData;
				}
			);
			loader.load(new URLRequest("assets/icon_image.png"));
			dateFormatter = new DateFormatter();
			dateFormatter.formatString = "YYYY-MM-DD-HH-NN-SS";
		}

		public function set displayObject(displayObject:DisplayObject):void {
			_displayObject = displayObject as InteractiveObject;
			_displayObject.addEventListener(MouseEvent.MOUSE_MOVE, startDragging);
		}

		private function startDragging(event:MouseEvent):void {
			if (!event.buttonDown) {
				return;
			}

			var options:NativeDragOptions = new NativeDragOptions();

			options.allowCopy = true;
			options.allowLink = true;
			options.allowMove = false;

			var data:Clipboard = new Clipboard();
			data.setData(ClipboardFormats.BITMAP_FORMAT, getBitmapData());
			data.setData(ClipboardFormats.FILE_LIST_FORMAT, [createTempImage()]);

			NativeDragManager.doDrag(_displayObject, data, dragIcon);
		}

		private function getBitmapData():BitmapData {
			var bd:BitmapData = new BitmapData(_displayObject.width, _displayObject.height);
			bd.draw(_displayObject);
			return bd;
		}

		private function createTempImage():File {
			var file:File = File.createTempDirectory().resolvePath(dateFormatter.format(new Date())+".png");
			var fileStream:FileStream = new FileStream();
			fileStream.open(file, FileMode.WRITE);
			fileStream.writeBytes(encodePNG());
			fileStream.close();
			return file;
		}

		private function encodePNG():ByteArray {
			var jpgEncoder:PNGEncoder = new PNGEncoder();
			var bytes:ByteArray = jpgEncoder.encode(getBitmapData());
			return bytes;
		}

	}
}